package com.ruoyi.system.mapper;

import java.util.List;
import com.ruoyi.system.domain.SysUserFollow;
import com.ruoyi.system.domain.dto.FollowerListDto;
import org.apache.ibatis.annotations.Param;

/**
 * 用户关注Mapper接口
 * 
 * @author haotian
 * @date 2024-12-02
 */
public interface SysUserFollowMapper 
{
    /**
     * 查询用户关注
     * 
     * @param id 用户关注主键
     * @return 用户关注
     */
    public SysUserFollow selectSysUserFollowById(Long id);

    /**
     * 查询用户关注列表
     * 
     * @param sysUserFollow 用户关注
     * @return 用户关注集合
     */
    public List<SysUserFollow> selectSysUserFollowList(SysUserFollow sysUserFollow);

    /**
     * 新增用户关注
     * 
     * @param sysUserFollow 用户关注
     * @return 结果
     */
    public int insertSysUserFollow(SysUserFollow sysUserFollow);

    /**
     * 修改用户关注
     * 
     * @param sysUserFollow 用户关注
     * @return 结果
     */
    public int updateSysUserFollow(SysUserFollow sysUserFollow);

    /**
     * 删除用户关注
     * 
     * @param id 用户关注主键
     * @return 结果
     */
    public int deleteSysUserFollowById(Long id);

    /**
     * 批量删除用户关注
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSysUserFollowByIds(Long[] ids);

    /*
     * 我的--查看我关注了那些人
     * */
    public List<FollowerListDto> getFollowerList(Long userId);

    /*
     * 我的--查看那些人关注了我
     * */
    public List<FollowerListDto> getFollowedList(Long userId);

    /*
     * 根据userId和followedUserId删除关注数据
     * */
    public int deleteSysUserFollowByUserIdAndFollowedUserId(@Param("userId") Long userId, @Param("followedUserId") Long followedUserId);

    /*
     * 获取我关注的人数
     * */
    public Long getFollowingCount(Long userId);

    /*
     * 获取关注我的人数
     * */
    public Long getFollowedCount(Long userId);

    /*
     * 获取新增关注列表
     * */
    public List<FollowerListDto> getAddFollowerList(Long userId);

    /*

    * 设置--注销账号--删除用户关注表中的数据
    */
    public int deleteSysUserFollowUserId(Long userId);
}
